import numpy
import pylab
import harkbasenode

class HarkNode(harkbasenode.HarkBaseNode):
    def __init__(self):
        self.outputNames = ("OUTPUT",)
        self.outputTypes = ("prim_int",)

        self.countdown = 10
        self.isFirst = True
        self.spectrum = []
        self.winlen = 100
        pylab.ion()
        pylab.hold(False)

    def calculate(self):
        self.outputValues["OUTPUT"] = 0
        tmp = numpy.array(self.SPECTRUM)
        if(numpy.sum(tmp) == 0):
            return;
        self.spectrum.append(tmp)
        self.countdown -= 1

        if self.countdown == 0:
            self.countdown = 10
            if len(self.spectrum) > self.winlen:
                self.spectrum = self.spectrum[len(self.spectrum)-self.winlen:]
            pylab.imshow(pylab.flipud(numpy.array(self.spectrum).transpose()),
                         aspect="auto", interpolation="nearest")
                
            if self.isFirst:
                pylab.colorbar()
                self.isFirst = False
            pylab.xlim([0, self.winlen])
            pylab.xlabel("Time")
            pylab.ylabel("Azimuth")
            pylab.draw()
        

